MURPHI2SMV(1)

NAME
murphi2smv - translate a Murphi model to SMV

SYNOPSIS
murphi2smv [--output FILE | -o FILE] FILE

DESCRIPTION
The utility murphi2smv is bundled with the model checker Rumur and can be used to translate a Murphi model into the input format to the NuSMV model checker. See rumur(1) for more information about Rumur or Murphi.

OPTIONS
--help or -?
    Display usage information.

--numeric-type [integer | word] or -n [integer | word]
    Set the SMV type used for ranges, scalarsets and numeric literals. This can be either integer to use native integers or word to use bit-vectors. If this option is omitted, one is chosen automatically based on the content of the input model.

--output FILE or -o FILE
    Set the path to write the output SMV model to. If this argument is omitted, output is written to standard out.

--quiet or -q
    Silence warning diagnostics.

--verbose or -v
    Report extra debugging information.

--version
    Display version information and exit.

NOTES
Translation to SMV is imprecise because the semantics of model execution in SMV are significantly different to Murphi. murphi2smv should not be expected to give you a ready-to-run SMV model. Rather it gives you an initial rough translation that you will need to edit to form a runnable model.

LIMITATIONS
Murphi type declarations have no exact equivalent in SMV. These are handled by propagating and expanding them inline. This is done purely syntactically, which can lead to unexpected or incorrect results if your input model has symbols that shadow other symbols.

The following Murphi constructs have no equivalent in SMV and are emitted as a placeholder comment:

    •   alias declarations

    •   alias rules

    •   alias statements

    •   assume, cover, and liveness properties

    •   clear statements

    •   error statements

    •   exists expressions

    •   for loops

    •   forall expressions

    •   functions, procedures, and calls to these

    •   if statements

    •   isundefined statements

    •   property statements

    •   quantifiers

    •   record definitions

    •   simple rules

    •   rulesets

    •   switch statements

    •   undefine statements

    •   while statements

You will need to either rephrase your input model to avoid these features or edit the generated SMV after generation.

Rumur supports integers up to 64-bit in width. SMV integers are only 32-bit. There are no checks that the numbers or calculations in the input model fit in 32-bit. This may result in constants or calculations in the generated SMV that overflow.

Murphi rule-local declarations and variables have no equivalent in SMV. These are emitted using SMV syntax but will need to be moved to a valid location within the SMV output.

SEE ALSO
rumur(1)

AUTHOR
All comments, questions and complaints should be directed to Matthew Fernandez <matthew.fernandez@gmail.com>.

LICENSE
This is free and unencumbered software released into the public domain.

Anyone is free to copy, modify, publish, use, compile, sell, or distribute this software, either in source code form or as a compiled binary, for any purpose, commercial or non-commercial, and by any means.

In jurisdictions that recognize copyright laws, the author or authors of this software dedicate any and all copyright interest in the software to the public domain. We make this dedication for the benefit of the public at large and to the detriment of our heirs and successors. We intend this dedication to be an overt act of relinquishment in perpetuity of all present and future rights to this software under copyright law.

THE SOFTWARE IS PROVIDED “AS IS”, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.

For more information, please refer to <http://unlicense.org>